Sponsored Content
Top Forums Shell Programming and Scripting Use parameter expansion over a parameter expansion in bash. Post 303043417 by wisecracker on Tuesday 28th of January 2020 10:53:10 AM
Old 01-28-2020
Hi nez...
I do not like 'eval' but here goes and is also 'dash' compliant...
Code:
Last login: Tue Jan 28 14:17:35 on ttys000
AMIGA:amiga~> dash
AMIGA:\u\w> path="/var/talend/nat/cdc"
AMIGA:\u\w> path=$( eval path=${path%/*} && echo ${_##*/} )
AMIGA:\u\w> echo "${path}"
nat
AMIGA:\u\w> exit
AMIGA:amiga~> _

 

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

removing html tags via parameter expansion

Hi all- I have a variable that contains a web page: echo $STUFF <html> <head> <title>my page</title></head> <body> blah blah etc.. Can I use the shell's parameter expansion abilities to remove just the tags? I thought that FIXHTML=${STUFF//<*>/} might do it, but it didn't seem to... (2 Replies)
Discussion started by: rev66
2 Replies

2. Shell Programming and Scripting

Need to print the expansion of the found string (the expansion is beween two delimiters '-' , '||'

Hi , could anyone help me out with this problem. sample.txt has this content : u001- this is used for project1 || u002- this is used for p2|| not to be printed u003- this is used for project3 || u004- this is used for p4 || u005- this is used for project5 || u006- this is used for p6... (9 Replies)
Discussion started by: Balaji PK
9 Replies

3. Shell Programming and Scripting

Need help with parameter expansion

Say you have this numeric variable that can be set by the user but you never want it to leave a certain range when it gets printed. How could you use parameter expansion such that it will never expand outside of that boundary? Thanks ---------- Post updated at 11:09 PM ---------- Previous update... (3 Replies)
Discussion started by: stevenswj
3 Replies

4. Shell Programming and Scripting

Bash parameter expansion from a config file

Hi - I am trying to do a simple config file with known variable names in it, e.g.: contents of config file a.conf: -a -b $work -c $host simplified contents of bash script file: work='trunk' host='alaska' opts=$(tr '\n' ' ' < a.conf) opts="$opts $*" mycommand $opts arg1 arg2 The... (3 Replies)
Discussion started by: mrengert
3 Replies

5. Shell Programming and Scripting

Parameter expansion not working for all strings...

I'm trying to write a script that parses my music collection and hard link some filenames that my media player doesn't like to other names. To do this I need to extract the name and remove alla non ASCII characters from that and do a cp -l with the result. Problem is this: 22:16:58 $... (8 Replies)
Discussion started by: refuser
8 Replies

6. UNIX for Dummies Questions & Answers

Parameter Expansion with regular expression

Hello experts, I am exploring parameter expansion, and trying to cut the fields in a URL. Following is the requirement: I have // abc.nnt /dir1/dir2/dir3/dir4/somefile.java What i need to get is the path after dir3, and dir3 will be passed. output that i need is... (1 Reply)
Discussion started by: gjarms
1 Replies

7. Shell Programming and Scripting

Bash Parameter Expansion

I have made the following examples that print various parameter expansions text: iv-hhz-sac/hpac/hhz.d/iv.hpac..hhz.d.2016.250.070018.sac (text%.*): iv-hhz-sac/hpac/hhz.d/iv.hpac..hhz.d.2016.250.070018 (text%%.*): iv-hhz-sac/hpac/hhz (text#*.): d/iv.hpac..hhz.d.2016.250.070018.sac... (2 Replies)
Discussion started by: kristinu
2 Replies

8. Shell Programming and Scripting

Bash Parameter Expansion

#!/bin/bash SNMPW='/usr/bin/snmpwalk' while read h i do loc=$($SNMPW -v3 -u 'Myusername' -l authPriv -a SHA -A 'Password1' -x AES -X 'Password2' $i sysLocation.0 2>/dev/null) loc=${loc:-" is not snmpable."} loc=${loc##*: } loc=${loc//,/} echo "$i,$h,$loc" done < $1 My question is ... ... (1 Reply)
Discussion started by: sumguy
1 Replies

9. Shell Programming and Scripting

Bash : More parameter expansion and IFS

I am trying to become more fluent with the interworking of bash and minimize the number of external calls. Sample Data. This will be the response of the snmp query. SNMPv2-MIB::sysName.0 = STRING: SomeHostName SNMPv2-MIB::sysObjectID.0 = OID: SNMPv2-SMI::enterprises.9.1.1745... (5 Replies)
Discussion started by: sumguy
5 Replies

10. Shell Programming and Scripting

Bash : Parameter expansion ${var:-file*}

Example data $ ls *somehost* 10.10.10.10_somehost1.xyz.com.log 11.11.11.11_somehost2.xyz.com.log #!/bin/bash #FILES="*.log" FILES=${FILES:-*.log} for x in $FILES do ip="${x%%_*}" # isolate IP address x="${x##*_}" # isolate hostname hnam="${x%.*}" # Remove the ".log"... (2 Replies)
Discussion started by: popeye
2 Replies
pathchk(1)							   User Commands							pathchk(1)

NAME
pathchk - check path names SYNOPSIS
pathchk [-p] path... DESCRIPTION
The pathchk command will check that one or more path names are valid (that is, they could be used to access or create a file without caus- ing syntax errors) and portable (that is, no filename truncation will result). More extensive portability checks are provided by the -p option. By default, pathchk will check each component of each path operand based on the underlying file system. A diagnostic will be written for each path operand that: o is longer than PATH_MAX bytes. o contains any component longer than NAME_MAX bytes in its containing directory o contains any component in a directory that is not searchable o contains any character in any component that is not valid in its containing directory. The format of the diagnostic message is not specified, but will indicate the error detected and the corresponding path operand. It will not be considered an error if one or more components of a path operand do not exist as long as a file matching the path name speci- fied by the missing components could be created that does not violate any of the checks specified above. OPTIONS
The following option is supported: -p Instead of performing checks based on the underlying file system, write a diagnostic for each path operand that: o is longer than _POSIX_PATH_MAX bytes o contains any component longer than _POSIX_NAME_MAX bytes o contains any character in any component that is not in the portable filename character set. OPERANDS
The following operand is supported: path A path to be checked. USAGE
See largefile(5) for the description of the behavior of pathchk when encountering files greater than or equal to 2 Gbyte ( 2**31 bytes). EXAMPLES
Example 1: Using the pathchk command To verify that all paths in an imported data interchange archive are legitimate and unambiguous on the current system: example% pax -f archive | sed -e '/ == .*/s///' | xargs pathchk if [ $? -eq 0 ] then pax -r -f archive else echo Investigate problems before importing files. exit 1 fi To verify that all files in the current directory hierarchy could be moved to any system conforming to the X/Open specification that also supports the pax(1) command: example% find . -print | xargs pathchk -p if [ $? -eq 0 ] then pax -w -f archive . else echo Portable archive cannot be created. exit 1 fi To verify that a user-supplied path names a readable file and that the application can create a file extending the given path without trun- cation and without overwriting any existing file: example% case $- in *C*) reset="";; *) reset="set +C" set -C;; esac test -r "$path" && pathchk "$path.out" && rm "$path.out" > "$path.out" if [ $? -ne 0 ]; then printf "%s: %s not found or %s.out fails creation checks. " $0 "$path" "$path" $reset # reset the noclobber option in case a trap # on EXIT depends on it exit 1 fi $reset PROCESSING < "$path" > "$path.out" The following assumptions are made in this example: 1. PROCESSING represents the code that will be used by the application to use $path once it is verified that $path.out will work as intended. 2. The state of the noclobber option is unknown when this code is invoked and should be set on exit to the state it was in when this code was invoked. (The reset variable is used in this example to restore the initial state.) 3. Note the usage of: rm "$path.out" > "$path.out" a. The pathchk command has already verified, at this point, that $path.out will not be truncated. b. With the noclobber option set, the shell will verify that $path.out does not already exist before invoking rm. c. If the shell succeeded in creating $path.out, rm will remove it so that the application can create the file again in the PRO- CESSING step. d. If the PROCESSING step wants the file to exist already when it is invoked, the: rm "$path.out" > "$path.out" should be replaced with: > "$path.out" which will verify that the file did not already exist, but leave $path.out in place for use by PROCESSING. ENVIRONMENT VARIABLES
See environ(5) for descriptions of the following environment variables that affect the execution of pathchk: LANG, LC_ALL, LC_CTYPE, LC_MESSAGES, and NLSPATH. EXIT STATUS
The following exit values are returned: 0 All path operands passed all of the checks. >0 An error occurred. ATTRIBUTES
See attributes(5) for descriptions of the following attributes: +-----------------------------+-----------------------------+ | ATTRIBUTE TYPE | ATTRIBUTE VALUE | +-----------------------------+-----------------------------+ |Availability |SUNWcsu | +-----------------------------+-----------------------------+ |Interface Stability |Standard | +-----------------------------+-----------------------------+ SEE ALSO
pax(1), test(1), attributes(5), environ(5), largefile(5), standards(5) SunOS 5.10 1 Feb 1995 pathchk(1)
All times are GMT -4. The time now is 02:51 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy